package cn.com.infosec.asn1.pkcs;

import cn.com.infosec.asn1.ASN1Encodable;
import cn.com.infosec.asn1.ASN1EncodableVector;
import cn.com.infosec.asn1.ASN1Sequence;
import cn.com.infosec.asn1.ASN1Set;
import cn.com.infosec.asn1.DERObject;
import cn.com.infosec.asn1.DERObjectIdentifier;
import cn.com.infosec.asn1.DERSequence;
import cn.com.infosec.asn1.DERTaggedObject;

public class SafeBag extends ASN1Encodable {
   DERObjectIdentifier bagId;
   DERObject bagValue;
   ASN1Set bagAttributes;

   public SafeBag(DERObjectIdentifier oid, DERObject obj) {
      this.bagId = oid;
      this.bagValue = obj;
      this.bagAttributes = null;
   }

   public SafeBag(DERObjectIdentifier oid, DERObject obj, ASN1Set bagAttributes) {
      this.bagId = oid;
      this.bagValue = obj;
      this.bagAttributes = bagAttributes;
   }

   public SafeBag(ASN1Sequence seq) {
      this.bagId = (DERObjectIdentifier)seq.getObjectAt(0);
      this.bagValue = ((DERTaggedObject)seq.getObjectAt(1)).getObject();
      if (seq.size() == 3) {
         this.bagAttributes = (ASN1Set)seq.getObjectAt(2);
      }

   }

   public DERObjectIdentifier getBagId() {
      return this.bagId;
   }

   public DERObject getBagValue() {
      return this.bagValue;
   }

   public ASN1Set getBagAttributes() {
      return this.bagAttributes;
   }

   public DERObject toASN1Object() {
      ASN1EncodableVector var1;
      ASN1EncodableVector var10001 = var1 = new ASN1EncodableVector;
      var1.<init>();
      var10001.add(this.bagId);
      var10001.add(new DERTaggedObject(0, this.bagValue));
      ASN1Set var2;
      if ((var2 = this.bagAttributes) != null) {
         var1.add(var2);
      }

      return new DERSequence(var1);
   }
}
